/*
 * OrderViewer.java
 *
 * Created on 10 de agosto de 2004, 18:08
 */

package com.fenalco.servlets.supplier;

import java.io.IOException;
import java.util.Hashtable;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.DataAccess;
import com.fenalco.entities.Order;
import com.fenalco.entities.Store;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.lists.OrderViewSupplier;

/**
 * Este servlet carga la información necesaria para mostrar los detalles de una
 * orden de compra.
 * 
 * Esta información es enviada a <CODE>ordencompra.jsp</CODE>
 * 
 * @author andres
 */
public class OrderViewer extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 *            Parámetro de configuración
	 * @throws ServletException
	 *             Excepción de fallo en la operación de inicialización
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destruye el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa las peticiones para los métodos HTTP <code>GET</code> y
	 * <code>POST</code>.
	 * 
	 * Este método crea un objeto Order con el id de la orden de compra
	 * seleccionada en el listado que aparece en <CODE>ordenescompra.jsp
	 * </CODE>.
	 * 
	 * Este objeto es enviado por medio del response a <CODE>ordencompra.jsp
	 * </CODE>
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo en la opeación de escritura con el fujo
	 *             <CODE>PrintWriter</CODE> de response
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		HttpSession session = request.getSession(false);
		RequestDispatcher dispatcher;
		String url;
		String message = "";

	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 2 )
			{
				url = "/logout";
				//message = "Sesión no iniciada";
				message = MessageBuilder.buildMessage(15);
			}
			else
			{
				Order order = new Order(new Integer(request.getParameter("key"))
						.intValue());
				OrderViewSupplier view = new OrderViewSupplier(order);
				Hashtable orderStatus = DataAccess.getOrderStatus(2);
				//System.out.println("Order id: "+order.getId()+" | Pertenece a:
				// "+order.getCompanyName());
	
				url = "/proveedor/ordencompra.jsp";
	
				if( view == null )
				{
					//Fallo al cargar la orden de compra
					//message = "Fallo al cargar la orden de compra";
					message = MessageBuilder.buildMessage(6);
	
				}
				else
				{
					//message = "Fallo al cargar la orden de compra";
					//message = MessageBuilder.buildMessage(3);
					message = "";
					request.setAttribute("order", order);
					String shopKeeperName = Store
							.getCompanyName(order.getStoreId());
					request.setAttribute("shopKeeperName", shopKeeperName);
					request.setAttribute("view", view);
					request.setAttribute("status", orderStatus);
				}
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }

		request.setAttribute("message", message);
		dispatcher = getServletContext().getRequestDispatcher(url);
		dispatcher.forward(request, response);
	}

	/**
	 * Maneja el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo en la opeación de escritura con el fujo
	 *             <CODE>PrintWriter</CODE> de response
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Maneja el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo en la opeación de escritura con el fujo
	 *             <CODE>PrintWriter</CODE> de response
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Información general del servlet.
	 * 
	 * @return Retorna descripción general del servlet
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}